##
##  perl-bytecode.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   versions of individual parts
%define       V_perl            5.22
%define       V_b_c             1.57
%define       V_b_utils         0.25
%define       V_b_recdeparse    0.10
%define       V_b_generate      1.56

#   package information
Name:         perl-bytecode
Summary:      Perl Modules for Bytecode Management
URL:          http://www.cpan.org/
Vendor:       Perl Community
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        BASE
Group:        Perl
License:      GPL/Artistic
Version:      %{V_perl}
Release:      20190507

#   list of sources
Source0:      http://www.cpan.org/authors/id/R/RU/RURBAN/B-C-%{V_b_c}.tar.gz
Source1:      http://www.cpan.org/authors/id/J/JJ/JJORE/B-Utils-%{V_b_utils}.tar.gz
Source2:      http://www.cpan.org/authors/id/V/VP/VPIT/B-RecDeparse-%{V_b_recdeparse}.tar.gz
Source3:      http://www.cpan.org/authors/id/R/RU/RURBAN/B-Generate-%{V_b_generate}.tar.gz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, perl >= %{V_perl}, perl-openpkg >= %{V_perl}-20040126
PreReq:       OpenPKG, openpkg >= 20160101, perl >= %{V_perl}
BuildPreReq:  perl-module
PreReq:       perl-module

%description
    Perl modules for Bytecode Management:
    - B::Compile (%{V_b_c})
    - B::Utils (%{V_b_utils})
    - B::RecDeparse (%{V_b_recdeparse})
    - B::Generate (%{V_b_generate})

%track
    prog perl-bytecode:B-C = {
        version   = %{V_b_c}
        url       = http://www.cpan.org/authors/id/R/RU/RURBAN/
        regex     = B-C-(__VER__)\.tar\.gz
    }
    prog perl-bytecode:B-Utils = {
        version   = %{V_b_utils}
        url       = http://www.cpan.org/authors/id/J/JJ/JJORE/
        regex     = B-Utils-(__VER__)\.tar\.gz
    }
    prog perl-bytecode:B-RecDeparse = {
        version   = %{V_b_recdeparse}
        url       = http://www.cpan.org/authors/id/V/VP/VPIT/
        regex     = B-RecDeparse-(__VER__)\.tar\.gz
    }
    prog perl-bytecode:B-Generate = {
        version   = %{V_b_generate}
        url       = http://www.cpan.org/authors/id/R/RU/RURBAN/
        regex     = B-Generate-(__VER__)\.tar\.gz
    }

%prep
    %setup -q -c
    %setup -q -T -D -a 1
    %setup -q -T -D -a 2
    %setup -q -T -D -a 3

%build

%install
    %{l_prefix}/bin/perl-openpkg prepare
    %{l_prefix}/bin/perl-openpkg -d %{SOURCE0} configure build install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin
    %{l_shtool} install -c -m 755 \
        -e 's;#! perl;#!%{l_prefix}/bin/perl;' \
        B-C-%{V_b_c}/script/perlcc.PL \
        $RPM_BUILD_ROOT%{l_prefix}/bin/perlcc
    %{l_prefix}/bin/perl-openpkg -d %{SOURCE1} configure build install
    %{l_prefix}/bin/perl-openpkg -d %{SOURCE2} configure build install
    %{l_prefix}/bin/perl-openpkg -d %{SOURCE3} configure build install
    %{l_prefix}/bin/perl-openpkg -F perl-openpkg-files fixate cleanup
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std} `cat perl-openpkg-files`

%files -f files

%clean

